#include "flt.h"
/** tB^[ENX`t@C
* \file flt.cpp
* fltNXECu`B̃NXECuVisualDSP++̊{tB^Q̃bp[
* łBwb_[Et@C flt.hB
*/
namespace flt{


    CFIRFilter::CFIRFilter
                    ( const shortfract h[], 
                      int tap,
                      shortfract d[] )
    {
        if ( d ) {                     // fBCC^ꂽ
            givenDelayLine = 1;             // ^ꂽ
        	state.d = (fract16 *) d;        // fBCC̐ݒ
        }
        else{
            givenDelayLine = 0;             // ^Ȃ
            state.d = (short*)new shortfract[tap];   // fBCC̊t
        }
        
    	state.h = (fract16 *)h;         // `B֐̐ݒ
    	state.k = tap;                  // ^bv̐ݒ
    	state.p = state.d;              // ǂݏo|C^̏
    	state.l = 0;                    // gp        
    	
    	        // fBCC̏
    	for ( int i=0; i< tap; i++ )
    	    state.d[i] = 0;
    }
    

    CFIRFilter::~CFIRFilter()
    {
    	if ( ! givenDelayLine )
    	    delete[] state.d;
    }
    
    void CFIRFilter::run( const shortfract input[], 
                          shortfract output[], 
                          int count )
    {
    	fir_fr16(           // VisualDSP++̃tB^֐
        	        (fract16 *)input, 
        	        (fract16 *)output, 
        	        count, 
        	        &state 
    	        );
    }
    

    CIIRFilter::CIIRFilter
                    ( const shortfract coeff[], 
                      int stage,
                      shortfract d[])
    {

    	
        if ( d ) {                     // fBCC^ꂽ
            givenDelayLine = 1;             // ^ꂽ
        	state.d = (fract16 *) d;        // fBCC̐ݒ
        }
        else{
            givenDelayLine = 0;             // ^Ȃ
            state.d = (short *)new shortfract[stage*2];   // fBCC̊t
        }
        
    	state.c = (fract16 *)coeff;         // `B֐̐ݒ
    	state.k = stage;                // ci̐ݒ
    	
    	        // fBCC̏
    	for ( int i=0; i< stage*2; i++ )
    	    state.d[i] = 0;
    }
    

    CIIRFilter::~CIIRFilter()
    {
    	if ( ! givenDelayLine )
    	    delete[] state.d;
    }
    
    void CIIRFilter::run( const shortfract input[], 
                          shortfract output[], 
                          int count )
    {
    	iir_fr16(           // VisualDSP++̃tB^֐
        	        (fract16 *)input, 
        	        (fract16 *)output, 
        	        count, 
        	        &state 
    	        );
    }
    
    CDecimator::CDecimator
                    ( const shortfract h[], 
                      int tap, 
                      int ratio,
                      shortfract d[] ) 
                            : CFIRFilter( h, tap, d )
    {
    	state.l = ratio;        // decimationϐɊi[    	
    }
    

    void CDecimator::run( const shortfract input[], 
                          shortfract output[], 
                          int count )
    {
    	fir_decima_fr16(           // VisualDSP++̃tB^֐
        	        (fract16 *)input, 
        	        (fract16 *)output, 
        	        count, 
        	        &state 
    	        );
    }
    
    CInterpolator::CInterpolator
                        ( const shortfract h[], 
                          int tap, 
                          int ratio,
                          shortfract d[] ) 
                                : CFIRFilter( h, tap/ratio, d )
    {
    	state.l = ratio;        // C^[|[VϐɊi[    	
    }
    
    
    void CInterpolator::run( const shortfract input[], 
                             shortfract output[], 
                             int count )
    {
    	fir_interp_fr16(           // VisualDSP++̃tB^֐
        	        (fract16 *)input, 
        	        (fract16 *)output, 
        	        count, 
        	        &state 
    	        );
    }
    
    extern "C" void _iir_fr16_ex( fract16 input[], fract16 output[], int count, iir_state_fr16 * d, const short sc[] );
    void CIIRFilterEx::run( const shortfract input[], 
                          shortfract output[], 
                          int count )
    {
    	_iir_fr16_ex(           // VisualDSP++̃tB^֐
        	        (fract16 *)input, 
        	        (fract16 *)output, 
        	        count, 
        	        &state,
        	        scaleFactor
    	        );
    }

        
};
